; XY - Diagrammdarstellung
;~~~~~~~~~~~~~~~~~~~~~~~~~~

;{- Konstanten

#ctxyChart_Date = -12
#ctxyChart_Time = -24
#ctxyChart_Point=  00
#ctxyChart_Line = -01

;} EndKonstanten

;{- Variablen

Structure xyChart_Format
   ID.i
   xRaster_Pos.i
   xRaster_Len.i
   xTeilung.b 
   xNachkomma.b
   xRight_Pos.i
   xLeft_Pos.i
   xLeft.f
   xRight.f
   xFontSize.f
   xTitle.s
   yRaster_Pos.i
   yRaster_Len.i
   yTeilung.b
   yNachkomma.b
   yDown_Pos.i
   yUp_Pos.i
   yDown.f
   yUp.f
   yFontSize.f
   yTitle.s
   Raster_Color.i
   Rahmen_Color.i
   Chart_Color.i
   Back_Color.i
   Front_Color.i
   Title.s
   DateForm.s
   TimeForm.s
EndStructure

Structure ctxyChart_Point
   x.f
   y.f
EndStructure

NewList ct_xyChart.xyChart_Format()

;} EndVariablen

;{- Declare

Declare.i ctxyChart_New(vID.i = #PB_Any)
Declare   ctxyChart_Present()
Declare   ctxyChart_Invers(vFlag.a = #True)
Declare   ctxyChart_Active(vList.i)
Declare   ctxyChart_Close(vList.i)
Declare   ctxyChart_Delete()
Declare   ctxyChart_RasterLen(vX.a = 86, vY.a = 76)
Declare     xyChart_Raster()
Declare     xyChart_Inscription()
Declare   ctxyChart_xKoordinate(vMin.f, vMax.f)
Declare   ctxyChart_yKoordinate(vMin.f, vMax.f)
Declare   ctxyChart_RasterColor(vColor.i)
Declare   ctxyChart_RahmenColor(vColor.i)
Declare   ctxyChart_ChartColor(vColor.i)
Declare   ctxyChart_BackColor(vColor.i)
Declare   ctxyChart_FrontColor(vColor.i)
Declare   ctxyChart_RasterPitch(vTeilung.i)
Declare.b ctxyChart_xRasterPitch(vTeilung.i = #PB_Any)
Declare.b ctxyChart_yRasterPitch(vTeilung.i = #PB_Any)
Declare   ctxyChart_Nachkomma(vNK.b)
Declare.b ctxyChart_xNachkomma(vNK.b = #PB_Any)
Declare.b ctxyChart_yNachkomma(vNK.b = #PB_Any)
Declare   ctxyChart_FontSize(vFontSize.f)
Declare.f ctxyChart_xFontSize(vFontSize.f = #Null)
Declare.f ctxyChart_yFontSize(vFontSize.f = #Null)
Declare.s ctXYChart_DateForm (vMaske.s = #NULL$)
Declare.s ctXYChart_TimeForm (vMaske.s = #NULL$)
Declare.i   xyChart_xPosition(vX.f)
Declare.i   xyChart_yPosition(vY.f)
Declare   ctxyChart_DrawPoint(vX.f, vY.f, vColor.i, vFlag.b = #Null)
Declare   ctxyChart_DrawList(List vXY.ctxyChart_Point(), vColor.i, vFlag.b = #PB_Any)
Declare.s ctxyChart_xPosition(vX.i) 
Declare.s ctxyChart_yPosition(vYy.i)
Declare   ctxyChart_Titel(vText.s)
Declare   ctxyChart_xTitel(vText.s)
Declare   ctxyChart_yTitel(vText.s)

;} EndDeclare

;{- InternProceduren

;Diagrammraster [Set|Intern]
Procedure xyChart_Raster()
   Shared ct_xyChart()
   Protected pY.i, pY1.i, pY2.i, pYs.i
   Protected pX.i, pX1.i, pX2.i, pXs.i
   
   With ct_xyChart()
      If (\ID=#PB_Any): ProcedureReturn: EndIf
      pX1 = GadgetWidth(\ID)  * \xRaster_Pos / 100       : \xLeft_Pos  = pX1
      pX2 = GadgetWidth(\ID)  * \xRaster_Len / 100 + pX1 : \xRight_Pos = pX2
      pXs = pX2 - pX1
      If (\xTeilung>#False)
         pXs = (pX2 - pX1) / \xTeilung
         pX2 = pX1 + pXs * \xTeilung : \xRight_Pos = pX2
      EndIf
      pY1 = GadgetHeight(\ID) * \yRaster_Pos / 100       : \yUp_Pos    = pY1
      pY2 = GadgetHeight(\ID) * \yRaster_Len / 100 + pY1 : \yDown_Pos  = pY2
      pYs = pY2 - pY1
      If (\yTeilung>#False)
         pYs = (pY2 - pY1) / \yTeilung
         pY2 = pY1 + pYs * \yTeilung : \yDown_Pos  = pY2
      EndIf
      If StartDrawing(CanvasOutput(\ID))
         Box(0, 0, GadgetWidth(\ID), GadgetHeight(\ID), \Back_Color)
         Box(\xLeft_Pos, \yDown_Pos, (\xRight_Pos-\xLeft_Pos), (\yUp_Pos-\yDown_Pos), \Chart_Color)
         pY = pY1
         Repeat  
            For pX=pX1-10 To pX2 Step 2
               Plot (pX, pY,  \Raster_Color)
            Next pX
            pY + pYs
         Until (pY=pY2+pYs)
         pX = pX1
         Repeat
            For pY=pY1 To pY2+10 Step 2
               Plot (pX, pY, \Raster_Color)
            Next pY
            pX + pXs
         Until (pX=pX2+pXs)
         If Not (\Rahmen_Color=#PB_Any)
            If \xTeilung: pXs * \xTeilung: EndIf
            If \yTeilung: pYs * \yTeilung: EndIf
            Line(pX1, pY2, pXs, 001, \Rahmen_Color)    
            Line(pX1, pY1, pXs, 001, \Rahmen_Color)    
            Line(pX1, pY1, 001, pYs, \Rahmen_Color)    
            Line(pX1+pXs, pY1, 001, pYs, \Rahmen_Color)  
         EndIf
         StopDrawing()
      EndIf
      xyChart_Inscription()
   EndWith         
EndProcedure

;Diagrammbeschriftung [Set|Intern]
Procedure xyChart_Inscription()
   Shared ct_xyChart()
   Protected pN.i, pFont.i, pFontID.i, pLen.f, pFlag.i
   Protected pX1s.i, pX1.i, pX2.f, pX2s.f, pXv.s, pXLeft.i
   Protected pY1s.i, pY1.i, pY2.f, pY2s.f, pYv.s, pYDown.i
   
   With ct_xyChart()
      pFont   = (GadgetWidth(\ID) * \xRaster_Len) / (3000 - \yUp_Pos * 2)
      pFontID = LoadFont(#PB_Any, "Arial", pFont)
      If StartDrawing(CanvasOutput(\ID))
         FrontColor (\Front_Color)
         DrawingMode(#PB_2DDrawing_Transparent)
         If pFontID: DrawingFont(FontID(pFontID)): EndIf
         pX1 = (\xRight_Pos + \xLeft_Pos) / 2 - Len(\Title) * pFont / 3.2
         pY1 = \yUp_Pos - TextHeight(\Title) ;(pFont * 1.8)         
         DrawText(pX1, pY1, \Title)
         StopDrawing()
         FreeFont(pFontID)
      EndIf
      Select \yNachkomma
         Case #ctxyChart_Date: pFlag = 1000 + Len(RemoveString(\DateForm, "%")) * 800
         Case #ctxyChart_Time: pFlag = 1000 + Len(RemoveString(\TimeForm, "%")) * 800
         Case #ctxyChart_Date|#ctxyChart_Time
            pFlag = 1000 + Len(RemoveString(\DateForm, "%")) * 800 
            If \yTeilung>10: \yTeilung = 10: EndIf
         Default: pFlag = 5800
      EndSelect
      If \yFontSize: pFont = \yFontSize: Else: pFont = GadgetWidth(\ID) * \xRaster_Len / pFlag: EndIf
      pFontID = LoadFont(#PB_Any, "Arial", pFont)
      If StartDrawing(CanvasOutput(\ID))
         FrontColor (\Front_Color)
         DrawingMode(#PB_2DDrawing_Transparent)
         If pFontID: DrawingFont(FontID(pFontID)): EndIf      
         pY1s  = (\yUp_Pos - \yDown_Pos) / \yTeilung
         pY1  = \YDown_Pos - pFont * 0.8    
         pY2  = \YDown
         If (\yNachkomma=#ctxyChart_Date|#ctxyChart_Time): pY1 - TextHeight("A") / 2: EndIf
         pY2s = (\YUp - \yDown) / \yTeilung
         Repeat            
            Select \yNachkomma
               Case #ctxyChart_Date: pYv = FormatDate(\DateForm, pY2)
               Case #ctxyChart_Time: pYv = FormatDate(\TimeForm, pY2)
               Case #ctxyChart_Date|#ctxyChart_Time: pYv = FormatDate(\DateForm, pY2)
               Default: pYv = StrF(pY2, \yNachkomma)
            EndSelect
            pX1 =\xLeft_Pos - TextWidth(pYv + Space(2))
            DrawText(pX1, pY1, pYv)
            If (\yNachkomma=#ctxyChart_Date|#ctxyChart_Time)
               pYv = FormatDate(\TimeForm, pY2)
               pX1 = \xLeft_Pos - TextWidth(pYv + Space(2))
               DrawText(pX1, pY1 + TextHeight(pYv), pYv)
            EndIf
            pY1 + pY1s: pY2 + pY2s
         Until (pY1<=(\yUp_Pos + pY1s))
         pX1 = (GadgetWidth(\ID) * 0.01) - (TextWidth(\yTitle) * 0.1)
         pY1 = GadgetHeight(\ID) - (GadgetHeight(\ID) - TextWidth(\yTitle)) / 2 
         DrawRotatedText(pX1, pY1, \yTitle, 90)
         StopDrawing()
      EndIf
      Select \xNachkomma
         Case #ctxyChart_Date: pFlag = 1000 + Len(RemoveString(\DateForm, "%")) * 800
         Case #ctxyChart_Time: pFlag = 1000 + Len(RemoveString(\TimeForm, "%")) * 800
         Case #ctxyChart_Date|#ctxyChart_Time
            pFlag = 1000 + Len(RemoveString(\DateForm, "%")) * 800
            If \xTeilung>10: \xTeilung = 10: EndIf
         Default: pFlag = 5800
      EndSelect
      If \xFontSize: pFont = \xFontSize: Else: pFont = GadgetWidth(\ID) * \xRaster_Len / pFlag: EndIf
      pFontID = LoadFont(#PB_Any, "Arial", pFont)
      If StartDrawing(CanvasOutput(\ID))
         FrontColor (\Front_Color)
         DrawingMode(#PB_2DDrawing_Transparent)
         If pFontID: DrawingFont(FontID(pFontID)): EndIf  
         pX1s = (\xRight_Pos - \xLeft_Pos) / \xTeilung
         pX2  = \xLeft
         pX2s = (\xRight - \xLeft) / \xTeilung
         pN = 0
         Repeat 
            Select \xNachkomma
               Case #ctxyChart_Date: pXv = FormatDate(\DateForm, pX2)
               Case #ctxyChart_Time: pXv = FormatDate(\TimeForm, pX2)
               Case #ctxyChart_Date|#ctxyChart_Time: pXv = FormatDate(\DateForm, pX2)
               Default: pXv  = StrF(pX2, \xNachkomma)
            EndSelect
            pX1  = \xLeft_Pos + (pN * pX1s) - (TextWidth(pXv) / 2)
            pY1  = \yDown_Pos + TextHeight(pXv)
            DrawText(pX1, pY1, pXv)
            If (\xNachkomma=#ctxyChart_Date|#ctxyChart_Time)
               pXv = FormatDate(\TimeForm, pX2)
               pX1  = \xLeft_Pos + (pN * pX1s) - (TextWidth(pXv) / 2)
               DrawText(pX1, pY1 + TextHeight(pYv), pXv)
            EndIf
            pN  + 1: pX2 + pX2s
         Until (pN>=(\xTeilung+1))
         pX1 = \xLeft_Pos + (\xRight_Pos - \xLeft_Pos - TextWidth(\xTitle)) / 2
         pY1 = GadgetHeight(\ID) - (GadgetHeight(\ID) * 0.01 + TextHeight(\xTitle) * 1.5)
         DrawText(pX1, pY1, \xTitle)
         StopDrawing()
         FreeFont(pFontID)
      EndIf
   EndWith
EndProcedure

;Konvertierung Punktkoordinate X-Achse [Set|Get|Intern]
Procedure.i xyChart_xPosition(vX.f)
   Shared ct_xyChart()
   Protected pPixel.i, pOffset.f, pWidth.f, pFactor.f, pPos.i
   
   With ct_xyChart()
      pPixel  = \xRight_Pos - \xLeft_Pos
      pOffset = vX - \xLeft
      pWidth  = \xRight - \xLeft
      pFactor = pOffset / pWidth
      pPos    = \xLeft_Pos + pPixel * pFactor
   EndWith
   ProcedureReturn pPos
EndProcedure

;Konvertierung Punktkoordinate Y-Achse [Set|Get|Intern]
Procedure.i xyChart_yPosition(vY.f)
   Shared ct_xyChart()
   Protected pPixel.i, pOffset.f, pHeight.f, pFactor.f, pPos.i
   
   With ct_xyChart()
      pPixel  = \yUp_Pos - \yDown_Pos
      pOffset = vY - \yDown
      pHeight = \yUp - \yDown
      pFactor = pOffset / pHeight
      pPos    = \yDown_Pos + pPixel * pFactor
   EndWith
   ProcedureReturn pPos
EndProcedure

;} EndInternProceduren

;{- ExternProceduren

;Erstellen eines neuen oder erneuern eines bestehenden Diagrammes [Set]
Procedure.i ctxyChart_New(vID.i = #PB_Any)                                             
   Shared ct_xyChart()

   With ct_xyChart() 
      If Not(vID=#PB_Any)
         AddElement(ct_xyChart())
         \ID = vID
         \Raster_Color = #Gray
         \Rahmen_Color = #Black
         \Chart_Color  = #White
         \Back_Color   = #White
         \Front_Color  = #Black
         \xNachkomma   = 1
         \xTeilung     = 10
         \xLeft        = 0
         \xRight       = 1
         \yNachkomma   = 1
         \yTeilung     = 10
         \yDown        = 0
         \yUp          = 1
         \DateForm     = "%dd.%mm.%yyyy" 
         \TimeForm     = "%hh:%ii:%ss"
      EndIf
;Raster-Groesse, Raster-Position  in  %  der Haupt-Fenster-Groesse.
      \xRaster_Pos  = 10
      \xRaster_Len  = 86
      \yRaster_Pos  = 10
      \yRaster_Len  = 76
   EndWith
   If Not(vID=#PB_Any): ProcedureReturn (ListSize(ct_xyChart()) - 1): EndIf
EndProcedure

;Anzeigen, Prsentieren [Set]
Procedure ctxyChart_Present()
      xyChart_Raster()
EndProcedure

;Schwarz-Wei/ Wei-Schwarz Darstellung [Set]
Procedure ctxyChart_Invers(vFlag.a = #True)
   Shared ct_xyChart()
   
   With ct_xyChart() 
      If vFlag
         \Raster_Color = #Gray
         \Rahmen_Color = #White
         \Chart_Color  = #Black
         \Back_Color   = #Black
         \Front_Color  = #White
      Else
         \Raster_Color = #Gray
         \Rahmen_Color = #Black
         \Chart_Color  = #White
         \Back_Color   = #White
         \Front_Color  = #Black
      EndIf
   EndWith
EndProcedure

;Aktivieren eines bestehenden Diagrammes [Set]
Procedure ctxyChart_Active(vList.i)
   Shared ct_xyChart()
   
   SelectElement(ct_xyChart(), vList)
EndProcedure

;Lschen eines bestehenden Diagrammes [Set]
Procedure ctxyChart_Close(vList.i)
   Shared ct_xyChart()
   
   SelectElement(ct_xyChart(), vList)
   ClearStructure(@ct_xyChart(), xyChart_Format)
   ct_xyChart()\ID = #PB_Any
EndProcedure

;Lschen aller bestehender Diagramme [Set]
Procedure ctxyChart_Delete()
   Shared ct_xyChart()
   
   ClearList(ct_xyChart())    
EndProcedure

;Raster-Groesse in % der Haupt-Fenster-Groesse [Set]
Procedure ctxyChart_RasterLen(vX.a = 86, vY.a = 76)
   Shared ct_xyChart()
   
   If (vX<90): ct_xyChart()\xRaster_Len = vX: EndIf
   If (vY<81): ct_xyChart()\yRaster_Len = vY: EndIf
EndProcedure

;Diagrammrasterfarbe [Set]
Procedure ctxyChart_RasterColor(vColor.i)
   Shared ct_xyChart()
   
   ct_xyChart()\Raster_Color = vColor
EndProcedure

;Diagrammrahmenfarbe [Set]
Procedure ctxyChart_RahmenColor(vColor.i)
   Shared ct_xyChart()
   
   ct_xyChart()\Rahmen_Color = vColor
EndProcedure

;Diagrammhintergrundfarbe [Set]
Procedure ctxyChart_ChartColor(vColor.i)
   Shared ct_xyChart()
   
   ct_xyChart()\Chart_Color = vColor
EndProcedure

;Hintergrundfarbe [Set]
Procedure ctxyChart_BackColor(vColor.i)
   Shared ct_xyChart()
   
   ct_xyChart()\Back_Color = vColor
EndProcedure

;Beschriftungsfarbe [Set]
Procedure ctxyChart_FrontColor(vColor.i)
   Shared ct_xyChart()
   
   ct_xyChart()\Front_Color = vColor
EndProcedure

;Rasterteilung XY-Achsen [Set]
Procedure ctxyChart_RasterPitch(vTeilung.i)
   Shared ct_xyChart()
   
   If (vTeilung=0): vTeilung = 1: EndIf
   ct_xyChart()\xTeilung = vTeilung
   ct_xyChart()\yTeilung = vTeilung
EndProcedure

;Rasterteilung X-Achse [Set|Get]
Procedure.b ctxyChart_xRasterPitch(vTeilung.i = #PB_Any)
   Shared ct_xyChart()
   
   If (vTeilung.i = #PB_Any)
      ProcedureReturn ct_xyChart()\xTeilung
   Else
      If (vTeilung=0): vTeilung = 1: EndIf
      ct_xyChart()\xTeilung = vTeilung
   EndIf
EndProcedure

;Rasterteilung Y-Achse [Set|Get]
Procedure.b ctxyChart_yRasterPitch(vTeilung.i = #PB_Any)
   Shared ct_xyChart()
   
   If (vTeilung.i = #PB_Any)
      ProcedureReturn ct_xyChart()\yTeilung
   Else
      If (vTeilung=0): vTeilung = 1: EndIf
      ct_xyChart()\yTeilung = vTeilung
   EndIf
EndProcedure

;Beschriftungswert Min-Max der X-Achse [Set]
Procedure ctxyChart_xKoordinate(vMin.f, vMax.f)
   Shared ct_xyChart()
   
   ct_xyChart()\xLeft  = vMin
   ct_xyChart()\xRight = vMax
EndProcedure

;Beschriftungswert Min-Max der Y-Achse [Set]
Procedure ctxyChart_yKoordinate(vMin.f, vMax.f)
   Shared ct_xyChart()
   
   ct_xyChart()\yDown  = vMin
   ct_xyChart()\yUp    = vMax
EndProcedure

;Nachkomma der XY-Achsen [Set]
Procedure ctxyChart_Nachkomma(vNK.b)
   Shared ct_xyChart()
   
   ct_xyChart()\xNachkomma = vNK
   ct_xyChart()\yNachkomma = vNK
EndProcedure 

;Nachkomma der X-Achse (NK oder #ctxyChart_Date|#ctxyChart_Time) [Set|Get]
Procedure.b ctxyChart_xNachkomma(vNK.b = #PB_Any)
   Shared ct_xyChart()
   
   If (vNK=#PB_Any)
      ProcedureReturn ct_xyChart()\xNachkomma
   Else
      ct_xyChart()\xNachkomma = vNK
   EndIf
EndProcedure 

;Nachkomma der Y-Achse  (NK oder #ctxyChart_Date|#ctxyChart_Time) [Set|Get]
Procedure.b ctxyChart_yNachkomma(vNK.b = #PB_Any)
   Shared ct_xyChart()
   
   If (vNK=#PB_Any)
      ProcedureReturn ct_xyChart()\yNachkomma
   Else
      ct_xyChart()\yNachkomma = vNK
   EndIf
EndProcedure 

;FontSize der XY-Achsen [Set]
Procedure ctxyChart_FontSize(vFontSize.f)
   Shared ct_xyChart()
   
   ct_xyChart()\xFontSize = vFontSize
   ct_xyChart()\yFontSize = vFontSize
EndProcedure

;FontSize der X-Achse [Set|Get]
Procedure.f ctxyChart_xFontSize(vFontSize.f = #Null)
   Shared ct_xyChart()
   
   If vFontSize
      ct_xyChart()\xFontSize = vFontSize
   Else
      ProcedureReturn ct_xyChart()\xFontSize
   EndIf      
EndProcedure

;FontSize der Y-Achse [Set|Get]
Procedure.f ctxyChart_yFontSize(vFontSize.f = #Null)
   Shared ct_xyChart()
   
   If vFontSize
      ct_xyChart()\yFontSize = vFontSize
   Else
      ProcedureReturn ct_xyChart()\yFontSize
   EndIf
EndProcedure

;DatumFormat (%dd.%mm.%yyyy) [Set|Get]
Procedure.s ctxyChart_DateForm (vMaske.s = #NULL$)
   
   Shared ct_xyChart()
   
   If vMaske
      ct_xyChart()\DateForm = vMaske
   Else
      ProcedureReturn ct_xyChart()\DateForm
   EndIf
EndProcedure

;ZeitFormat (%hh:%ii:%ss) [Set|Get]
Procedure.s ctxyChart_TimeForm (vMaske.s = #NULL$)
   Shared ct_xyChart()
   
   If vMaske
      ct_xyChart()\TimeForm = vMaske
   Else
      ProcedureReturn ct_xyChart()\TimeForm
   EndIf
EndProcedure

;Zeichnen von Diagrammpunkten [Set]
Procedure ctxyChart_DrawPoint(vX.f, vY.f, vColor.i, vFlag.b = #Null)
   Shared ct_xyChart()
   Protected pX.i, pY.i
   
   With ct_xyChart()
      If (vX<ct_xyChart()\xLeft) Or (vX>ct_xyChart()\xRight)
         ProcedureReturn
      Else
         pX = xyChart_xPosition(vX)
      EndIf
      If (vY<ct_xyChart()\yDown) Or (vY>ct_xyChart()\yUp)
         ProcedureReturn
      Else
         pY =  xyChart_yPosition(vY)
      EndIf
      If StartDrawing(CanvasOutput(\ID))
         If vFlag
            Circle(pX, pY, Abs(vFlag), vColor)
         Else
            Plot(pX, pY, vColor)
         EndIf
         StopDrawing()
      EndIf
   EndWith
EndProcedure

;Zeichnen der Diagrammkurve [Set]
Procedure ctxyChart_DrawList(List vXY.ctxyChart_Point(), vColor.i, vFlag.b = #PB_Any)
   Shared ct_xyChart()
   Protected pX1.i, pX2.i, pY1.i, pY2.i, pDraw.a
   
   If StartDrawing(CanvasOutput(ct_xyChart()\ID))
      FirstElement(vXY())
      With ct_xyChart()
         If (vXY()\x<\xLeft) 
            pX2 = \xLeft_Pos
         ElseIf (vXY()\x>\xRight)
            pX2 = \xRight_Pos
         Else
            pX2 = xyChart_xPosition(vXY()\x)
         EndIf
         If (vXY()\y<\yDown)
            pY2 = \yDown_Pos
         ElseIf (vXY()\y>\yUp)
            pY2 = \yUp_Pos
         Else
            pY2 = xyChart_yPosition(vXY()\y)
         EndIf
      EndWith
      ForEach vXY()
         With vXY()
            If (\x<ct_xyChart()\xLeft) Or (\x>ct_xyChart()\xRight)
               pDraw = #False
            Else
               pX1 = xyChart_xPosition(\x): pDraw = #True
            EndIf
            If (\y<ct_xyChart()\yDown) Or (\y>ct_xyChart()\yUp)
               pDraw = #False
            Else
               pY1 = xyChart_yPosition(\y)
               If pDraw: pDraw = #True: EndIf
            EndIf
            If pDraw
               Select vFlag
                  Case #ctxyChart_Point: Plot(pX1, pY1 , vColor)
                  Case #ctxyChart_Line : LineXY(pX2, pY2, pX1, pY1, vColor)
                  Default: Circle(pX1, pY1, vFlag, vColor)
               EndSelect
               pX2 = pX1: pY2 = pY1
            EndIf
         EndWith
      Next
      StopDrawing()
   EndIf
EndProcedure

;Konvertierung Wert X-Achse [Set|Get]
Procedure.s ctxyChart_xPosition(vX.i)
   Shared ct_xyChart()
   Protected pPixel.f, pOffset.f, pWidth.f, pFactor.f, pPos.f, pResult.s
   
   With ct_xyChart()
      If (vX<\xLeft_Pos) Or (vX>\xRight_Pos): ProcedureReturn: EndIf
      pPixel  = \xRight_Pos - \xLeft_Pos
      pWidth  = \xRight - \xLeft
      pFactor = (vX - \xLeft_Pos) / pPixel
      pOffset = pWidth * pFactor
      pPos    = pOffset + \xLeft
      Select \xNachkomma
         Case #ctxyChart_Date: pResult = FormatDate(\DateForm, pPos)
         Case #ctxyChart_Time: pResult = FormatDate(\TimeForm, pPos)
         Case #ctxyChart_Date|#ctxyChart_Time: pResult = FormatDate(\DateForm + Space(1) + \TimeForm, pPos)
         Default: pResult = StrF(pPos)
      EndSelect
   EndWith
   ProcedureReturn pResult
EndProcedure

;Konvertierung Wert Y-Achse [Set|Get]
Procedure.s ctxyChart_yPosition(vY.i)
   Shared ct_xyChart()
   Protected pPixel.f, pOffset.f, pHeight.f, pFactor.f, pPos.f, pResult.s
   
   With ct_xyChart()
      If (vY<\yUp_Pos) Or (vY>\yDown_Pos): ProcedureReturn: EndIf
      pPixel  = \yUp_Pos - \yDown_Pos
      pHeight = \yUp - \yDown
      pFactor = (vY - \yDown_Pos) / pPixel
      pOffset = pHeight * pFactor
      pPos    = pOffset + \yDown
      Select \yNachkomma
         Case #ctxyChart_Date: pResult = FormatDate(\DateForm, pPos)
         Case #ctxyChart_Time: pResult = FormatDate(\TimeForm, pPos)
         Case #ctxyChart_Date|#ctxyChart_Time: pResult = FormatDate(\DateForm + Space(1) + \TimeForm, pPos)
         Default: pResult = StrF(pPos)
      EndSelect
   EndWith
   ProcedureReturn pResult
EndProcedure

;Diagrammberschrift [Set]
Procedure ctxyChart_Titel(vText.s)
   Shared ct_xyChart()
   
   ct_xyChart()\Title = vText
EndProcedure

;xAchsenbeschriftung [Set]
Procedure ctxyChart_xTitel(vText.s)
   Shared ct_xyChart()
   
   ct_xyChart()\xTitle = vText
EndProcedure

;yAchsenbeschriftung [Set]
Procedure ctxyChart_yTitel(vText.s)
   Shared ct_xyChart()
   
   ct_xyChart()\yTitle = vText
EndProcedure

;} EndExternProceduren
